// DFIconButton
//
// Copyright 1996 Thorsten Seitz

#include "DFIconButton.h"
#include "get_icon.h"


// class DFIconButton

#pragma mark ## ICON_BUTTON

DFIconButton::DFIconButton(
						BWindow *window,
						BRect frame,
						const char *name,
						long type_off, 
						long type_on, 
						long creator,
						long base_off,
						long base_on,
						long base_creator,
						BMessage *msg,
						ulong behaviour,
						ulong resizingMode,
						ulong flags)
	: BPictureButton(
				frame,
				name,
				GetPicture(window, frame, type_off, creator, base_off, base_creator, FALSE),
				GetPicture(window, frame, type_on, creator, base_on, base_creator, TRUE),
				msg,
				behaviour,
				resizingMode,
				flags)
{
}


BPicture*
DFIconButton::GetPicture(
				BWindow *window,
				BRect rect,
				long type, 
				long creator,
				long base_type, 
				long base_creator,
				bool on)			
{
	BBitmap bmp(BRect(0,0,15,15), B_COLOR_8_BIT);

	get_icon(type, creator, "smallBits", &bmp);
	
	return GetPicture(window, rect, &bmp, base_type, base_creator, on);
}


BPicture*
DFIconButton::GetPicture(
				BWindow *window,
				BRect rect,
				BBitmap *bmp,
				long base_type, 
				long base_creator,
				bool on)			
{
	BPicture 	*pic;
	
	window->Lock();
	
	rect.OffsetTo(B_ORIGIN);
	
	BBitmap base(BRect(0,0,31,31), B_COLOR_8_BIT);
	
	BView *picView = new BView(rect, "", B_FOLLOW_NONE, 0);
	picView->Hide();
	window->AddChild(picView);
	
	picView->BeginPicture(new BPicture);
	if (!base_type)
		picView->DrawBitmap(bmp);
	else {
		get_icon(base_type, base_creator, "largeBits", &base);
		picView->DrawBitmap(&base, rect, rect);
		picView->SetDrawingMode(B_OP_OVER);
		picView->DrawBitmap(bmp, on ? BPoint(2,2) : BPoint(3,3));
	}
	pic = picView->EndPicture();
	
	window->Unlock();

	return pic;	
}
