// DFIconButton
//
// Copyright 1996 Thorsten Seitz
//
// DFIconButton:
//		a BPictureButton, where the picture are icons given by
//		type_on, type_off and the common creator
//		(this makes it possible to include these icons as resources)
//		the unaugmented flag specifies whether the icons shall be
//		used unaugmented or be augmented with an underlying
//		button (a bigger grey version of the windows close button)

#ifndef DF_ICON_BUTTON_H
#define DF_ICON_BUTTON_H

// class DFIconButton

class
DFIconButton : public BPictureButton
{

public:
						DFIconButton(
								BWindow *window,
								BRect frame,
								const char *name,
								long type_off,
								long type_on,
								long creator,
								long base_off,
								long base_on,
								long base_creator,
								BMessage *msg,
								ulong behaviour = B_ONE_STATE_BUTTON,
								ulong resizingMode 
									= B_FOLLOW_LEFT | B_FOLLOW_TOP,
								ulong flags = B_WILL_DRAW);

	virtual				~DFIconButton() {}
	
protected:
			BPicture*	GetPicture(
							BWindow *window, 
							BRect rect,
							long type,
							long creator, 
							long base_type,
							long base_creator,
							bool on);
							
			BPicture*	GetPicture(
							BWindow *window, 
							BRect rect,
							BBitmap *bmp, 
							long base_type,
							long base_creator,
							bool on);
};
					
#endif

