// MiniWindowDaemon
// Copyright 1996 Thorsten Seitz

#include "DFMiniWindowDaemon.h"
#include "DFApplication.h"
#include "DFWindow.h"

#define INSET (TOP + TOP)


DFMWDApplication::DFMWDApplication()
	: BApplication('?MWD')
{
	fApps = 0;
}


DFMWDApplication::~DFMWDApplication()
{
	long i;
	
	for (i=0; i<fFrames.CountItems(); i++)
		delete static_cast<BRect*>(fFrames.ItemAt(i));
}


void
DFMWDApplication::MessageReceived(BMessage *msg)
{
	screen_info info;
	long 		i;
	bool		success;
	float		x,y;
	BRect		frame;
	
	switch (msg->what) {
	
	case DF_LOCATION:
		BPoint point = msg->FindPoint("point");
		frame = BRect(point, point+BPoint(47,45));
		frame.InsetBy(-INSET, -INSET);
		BRegion *region = new BRegion;
		for (i=0; i < fFrames.CountItems(); i++)
			region->Include(*static_cast<BRect*>(fFrames.ItemAt(i)));
		if (region->Intersects(frame)) {
			get_screen_info(&info);
			success = FALSE;
			for (y=TOP; y<=info.frame.bottom-GRID_Y+BOTTOM_OFFSET; y+=GRID_Y) {
				for (x=DOCK_WIDTH; x<=info.frame.right-GRID_X+RIGHT_OFFSET; x+=GRID_X) {
					frame.Set(x,y,x+47,y+45);
					frame.InsetBy(-INSET,-INSET);
					if (!region->Intersects(frame)) {
						success = TRUE;
						goto exit;
					}
				}
			}
			exit:
			if (!success) frame.OffsetTo(DOCK_WIDTH, TOP);
		}
		delete region;
		frame.InsetBy(INSET, INSET);
		BRect *rect = new BRect(frame);
		fFrames.AddItem(static_cast<void*>(rect));
		fMinis.AddItem(static_cast<void*>(msg->FindObject("mini")));
		
		BMessage *reply = new BMessage(DF_LOCATION);
		reply->AddPoint("point", frame.LeftTop());
		msg->SendReply(reply);
		break;
		
	case DF_REMOVE_ITEM:
		i = fMinis.IndexOf(
			static_cast<void*>(msg->FindObject("mini")));
		if (i>=0) {
			fMinis.RemoveItem(i);
			fFrames.RemoveItem(i);
		}
		break;
		
	case DF_MOVED:
		i = fMinis.IndexOf(
			static_cast<void*>(msg->FindObject("mini")));
		if (i>=0) {
			BPoint point = msg->FindPoint("point");
			*static_cast<BRect*>(fFrames.ItemAt(i)) = BRect(point, point + BPoint(47,45));
		}	
		break;
		
	case DF_ADD:
		fApps++;
		break;
		
	case DF_QUIT:
		fApps--;
		if (fApps == 0)
			be_app->PostMessage(B_QUIT_REQUESTED);
		break;
	
	default:
		inherited::MessageReceived(msg);
		break;
	}
}


main()
{	
	DFMWDApplication *daemon;

	daemon = new DFMWDApplication();
	daemon->Run();
	
	delete(daemon);
	return(0);
}
