// get_icon
//
// Copyright 1996 Thorsten Seitz

#include "get_icon.h"


#pragma mark ## GLOBAL FUNCTIONS

record_id					// record_id of the icon
get_icon(
		long type, 			// icon type
		long creator, 		// icon creator
		const char *bits, 	// "smallBits" or "largeBits"
		BBitmap *bmp)		// target bitmap (16x16 or 32x32, resp.)
{
	BDatabase 	*db;
	record_id	icon_id;
	void		*data;
	long		size;
	BQuery 		query;
	 
	db = boot_volume().Database();
	
	query.AddTable(db->FindTable("Icon"));
	query.PushField("type");
	query.PushLong(type);
	query.PushOp(B_EQ);
	query.PushField("creator");
	query.PushLong(creator);
	query.PushOp(B_EQ);
	query.PushOp(B_AND);
	
	query.Fetch();
	
	if (query.CountRecordIDs() == 0)
		icon_id = BINARY_ICON_ID;
	else
		icon_id = query.RecordIDAt(0);

	BRecord icon(db, icon_id);	
			
	data = icon.FindRaw(bits, &size);

	if (bmp) {
		bmp->SetBits(data, size, 0, B_COLOR_8_BIT);
	}
	
	return icon_id;
}
